procedure cmd_PUTS(sequence s)
  puts(1,s)
end procedure

procedure cmd_PUTI(integer i)
  printf(1,"%d",{i})
end procedure

procedure cmd_NOOP()
  -- NOOP
end procedure

procedure cmd_GOTO(sequence l)
  goto(l)
end procedure

procedure cmd_STORE(sequence varname, object val)
  set_var(varname,val)
end procedure

procedure cmd_EQUAL(object exp1, object exp2, sequence true,sequence false)
  if equal(exp1,exp2) then
    goto(true)
  else
    goto(false)
  end if
end procedure

procedure cmd_LESS(object exp1, object exp2, sequence t, sequence f)
  if compare(exp1,exp2)=-1 then
    goto(t)
  else
    goto(f)
  end if
end procedure

procedure cmd_GREATER(object exp1, object exp2, sequence t, sequence f)
  if compare(exp1,exp2) > 0 then
    goto(t)
  else
    goto(f)
  end if
end procedure

procedure cmd_NEQUAL(object exp1, object exp2, sequence t, sequence f)
  if not equal(exp1,exp2) then
    goto(t)
  else
    goto(f)
  end if
end procedure

procedure cmd_ADD(object x1,object x2,sequence res)
  set_var(res,x1+x2)
end procedure

procedure cmd_SUB(object x1,object x2,sequence res)
  set_var(res,x1-x2)
end procedure

procedure cmd_MUL(object x1,object x2,sequence res)
  set_var(res,x1*x2)
end procedure

procedure cmd_DIV(object x1,object x2,sequence res)
  set_var(res,x1/x2)
end procedure

-- add commands
add_command("NOOP",routine_id("cmd_NOOP"))
add_command("GOTO",routine_id("cmd_GOTO"))
add_command("STORE",routine_id("cmd_STORE"))
add_command("EQUAL",routine_id("cmd_EQUAL"))
add_command("LESS",routine_id("cmd_LESS"))
add_command("GREATER",routine_id("cmd_GREATER"))
add_command("ADD",routine_id("cmd_ADD"))
add_command("SUB",routine_id("cmd_SUB"))
add_command("MUL",routine_id("cmd_MUL"))
add_command("DIV",routine_id("cmd_DIV"))
add_command("PUTS",routine_id("cmd_PUTS"))
add_command("PUTI",routine_id("cmd_PUTI"))
add_command("NEQUAL",routine_id("cmd_NEQUAL"))

