-- DEMO2.EX : demonstrate how to do a loop with the commands provided

include engine.e

sequence thescript
-- To simulate looping you have to have a condition evaluation with a label
-- and a GOTO statement that will return to that statement. you should also
-- declare a 'evaluation variable' to evaluate counters or flags and such.

thescript =
{
  -- this will be our 'evaluation variable'.
  {"","store",{"control",0}},
  {"","PUTS",{"Start of loop\n"}},

  -- loop starts here(use the other loops to see how to perform other types of looping)
  {"check_cond","NEQUAL",{"$control",10, "loop2","loop1"}}, -- while control != 10
--{"check_cond","LESS",{"$control",10,"loop2","loop1"}},    -- while control < 10
--{"check_cond","GREATER",{10,"$control","loop2","loop1"}}, -- while 10 > control

  {"loop2","ADD",{"$control",1,"control"}},
  {"","PUTS",{"  Variable = "}},
  {"","PUTI",{"$control"}},
  {"","PUTS",{"\n"}},
  {"","GOTO",{"check_cond"}},
  -- loop ends here

  {"loop1","PUTS",{"End of loop\n"}}
} -- end of script.

puts(1,"-- SCRIPT OUTPUT --\n")
execute(thescript)
puts(1,"-- END OF SCRIPT --")

