-- DEMO3.EX : demonstrate how to define your own commands

include engine.e

-- this command increments a variable
procedure cmd_INC(sequence varname)
  object x
  -- use get_var() to get variables inside a command procedure
  x = get_var(varname)
  x = x + 1
  set_var(varname,x)
end procedure

add_command("INC",routine_id("cmd_INC"))

-- this command increments a variable
procedure cmd_DEC(sequence varname)
  object x
  -- use get_var() to get variables inside a command procedure
  x = get_var(varname)
  x = x - 1
  set_var(varname,x)
end procedure

add_command("DEC",routine_id("cmd_DEC"))

-- now use the new commands in a script
sequence thescript
thescript =
{
  {"","INC",{"i"}},
  {"","INC",{"i"}},
  {"","DEC",{"i"}},
  {"","PUTI",{"$i"}}
}

execute(thescript)


